#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClient.h>

#ifndef APSSID
#define APSSID "ESPap"
#define APPSK "thereisnospoon"
#endif

#define BUTTON D2

/* Set these to your desired credentials. */
const char *APssid = APSSID;
const char *APpassword = APPSK;

const char *ssid = "Apto202";
const char *password = "gatocafe";

ESP8266WebServer web_server(80);
WiFiClient wifiClient;

String HOST_ADDRESS = "192.168.0.47";

String make_toggle_request()
{
  HTTPClient http;
  String ADCData, station, getData, request;

  request = "http://" + HOST_ADDRESS + "/cm?cmnd=Power24%20Toggle";
  Serial.println("Sent request to:" + request);
  http.begin(wifiClient, request);

  auto httpCode = http.GET();
  String response = http.getString();
  http.end();

  return response;
}

void handleRoot()
{
  String response = make_toggle_request();
  web_server.send(200, "text/html", response);
}

void handleSetHost()
{
  String host = web_server.arg("host");
  Serial.println("Setting host to: " + host);
  HOST_ADDRESS = host;
}

void setup()
{
  pinMode(BUTTON, INPUT_PULLUP);
  delay(1000);
  Serial.begin(9600);
  Serial.println("Init");
  Serial.print("Configuring access point...");
  /* You can remove the password parameter if you want the AP to be open. */

  // WiFi.mode(WIFI_AP_STA);
  // WiFi.softAP(APssid, APpassword);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print('.');
    delay(1000);
  }
  //  Serial.println(WiFi.localIP());
  //  Serial.println(WiFi.softAPIP());
  Serial.print("AP IP address: ");
  Serial.println(WiFi.localIP());
  web_server.on("/", handleRoot);
  web_server.on("/sethost", handleSetHost);
  web_server.begin();
  Serial.println("HTTP server started");
}

void loop()
{
  if(digitalRead(BUTTON) == LOW) {
    //digitalWrite(LED_BUILTIN, HIGH);
    //int v = digitalRead(BUTTON);
    //Serial.print("READ: ");
    //Serial.println(v);
    // Wait for the button to be released
    //while(digitalRead(BUTTON) == LOW) {
    //  delay(100);    
    //}
    //digitalWrite(LED_BUILTIN, LOW);
    //Serial.println("BOO");
    make_toggle_request();
    delay(500);
  }

  web_server.handleClient();
}
